function [mu_old, PHI_old, B_old, mhtune] = ...
    draw_muPHIB(YYY,XXX,SIG_old, ...
    ndim, nlag, ldim, prior, mhtune, nobs, fun_mean)


    %% Step (): Update mu&B together (conditional mean parameters)
    %% Molin Edit: Update mu&B together (conditional mean parameters)
    %Ordering is: mu; phi(:,1); phi(:,2); B(:,1); B(:,2)
    % YYY = ytoday
    % XXX = [ylag(1), ylag(2), ..., ylag(nlag)];
    % prior.muPHIB.m = [prior.m; prior.phi; prior.b]; %prior
    % prior.muPHIB.V = blkdiag(prior.M, prior.PHI, prior.B); %prior
    
    ss_x0 = prior.muPHIB.m;
    ss_P0 = prior.muPHIB.V;

    ss_yt = zeros(ndim*nobs,1);
    ss_Bt = zeros(ndim*nobs, (1 +ndim*nlag + ldim)*ndim); % [constant vecphi(1) ... vecphi(nlag) vecB]
    for t = 1:1:nobs
        ss_Httemp = chol(SIG_old(:,:,t),'lower');
        ss_Ytemp1 = YYY(t,:)';
        ss_Ytemp0 = [1 XXX(t,:) fun_mean(SIG_old(:,:,t))'];
        ss_yt((t-1)*ndim+1:t*ndim,1) = ss_Httemp\ss_Ytemp1;
        ss_Bt((t-1)*ndim+1:t*ndim,:) = kron(ss_Ytemp0,inv(ss_Httemp));
    end
    %ss_yt = ss_yt(nlag*ndim+1:end);   % *** change due to VAR notation
    %ss_Bt = ss_Bt(nlag*ndim+1:end,:); % *** change due to VAR notation
    
    bbeta_ml = (ss_Bt'*ss_Bt)\(ss_Bt'*ss_yt);
%     s_up     = (inv(ss_P0)+ss_Bt'*ss_Bt)\(ss_P0\ss_x0 + ss_Bt'*ss_Bt*bbeta_ml);
    s_up     = (eye(length(ss_P0))/ss_P0+ss_Bt'*ss_Bt)\(ss_P0\ss_x0 + ss_Bt'*ss_Bt*bbeta_ml);
%     P_up     = inv(inv(ss_P0)+ss_Bt'*ss_Bt);
    P_up     = eye(length(ss_Bt'*ss_Bt))/(eye(length(ss_P0))/ss_P0+ss_Bt'*ss_Bt);
    P_up     = triu(P_up) + triu(P_up,1)'; %3-13-17 Molin add: Ensuring symmetry
    
    temp_draw = s_up + chol(P_up,'lower')*randn(size(s_up,1),1);
    
    mu_old  = temp_draw(1:ndim);
    PHI_old = reshape(temp_draw(ndim+1:ndim+ndim*ndim*nlag),ndim,[]);
    B_old   = reshape(temp_draw(ndim+ndim*ndim*nlag+1:end),ndim,[]);
    
    