function nu_old = draw_nu_griddy(SIG_old, SIGinv_old, A, C, prior)

% -----
% drawing nu
%     SIG_old = p_sm_old;
%     SIGinv_old = p_sminv_old;

[ndim,ndim,nobs] = size(SIG_old);


% nu density
termA = 0; % log det of (C+A*SIG*A')
termB = 0; % log det of SIG
termC = 0; % trace of (C+A*SIG*A')/SIG

for t=2:1:nobs
    CpASA = C+A*SIG_old(:,:,t-1)*A';
    termA = termA + log(det(CpASA));
    termB = termB + log(det(SIG_old(:,:,t)));
    termC = termC + trace( CpASA*SIGinv_old(:,:,t) );
end

T = (nobs-1); %first SIG is not a function of nu but nu0

temp_nu = prior.nu.grid; %grid for nu
log_nu_pdf = ...
    ( (temp_nu/2).*log(temp_nu-ndim-1) )*T*ndim ... %it is important to add *ndim !!!
    + (temp_nu/2)*termA ...
    - T*temp_nu*ndim/2*log(2) ...
    - T*logmvgamma(temp_nu/2,ndim) ... %- T*gammaln(temp_nu/2) ...
    - (temp_nu+ndim+1)/2 * termB ...
    - (temp_nu-ndim-1)/2 * termC ...
    + (prior.nu.a-1)*log(temp_nu) - temp_nu/prior.nu.b - gammaln(prior.nu.a) - prior.nu.a*log(prior.nu.b);

%     log_nu_prior = (prior.nu.a-1)*log(temp_nu) - temp_nu/prior.nu.b - gammaln(prior.nu.a) - prior.nu.a*log(prior.nu.b);

nu_post = exp(log_nu_pdf-max(log_nu_pdf));
nu_post = nu_post/sum(nu_post);
nu_post_cum = cumsum(nu_post);

% inverse cdf method with linear interpolication
u_prop = rand;
temp_i0 = find(nu_post_cum<u_prop);
i0 = temp_i0(end);
i1 = i0+1;
p0 = nu_post_cum(i0);
p1 = nu_post_cum(i1);

nu_old = ( (u_prop-p0)/(p1-p0) ) * (temp_nu(i1)-temp_nu(i0)) + temp_nu(i0);

