function Inuwishinv = gen_Inuwishinv(c2r,snr) %#codegen
% c2r = chi2rnd(df-(0:n-1)); (ndim,NN,nlength)
% snr = randn(n*(n-1)/2,1); ( (ndim*(ndim-1)/2), NN, nlength))

% dimension info
[ndim,NN,nlength] = size(c2r);

% wishart shocks, ndim*ndim*NN*nlength
% I = eye(ndim);
% Inuwish = zeros(ndim,ndim,NN,nlength);
Inuwishinv = zeros(ndim,ndim,NN,nlength);
for j=1:1:nlength
    for i=1:1:NN
        
        % Load diagonal elements with square root of chi-square variates
        % c2r = chi2rnd(df-(0:n-1)); (ndim,NN,nlength)
        a = diag(sqrt(c2r(:,i,j)));
        
        % Load upper triangle with independent normal (0, 1) variates
        % snr = randn(n*(n-1)/2,1); ( (ndim*(ndim-1)/2), NN, nlength))
        a(itriu(ndim)) = snr(:,i,j);
        
        Inuwishinv(:,:,i,j) = pdinv(a'*a);
        %Inuwish(:,:,i,j)    = a'*a;
        %Inuwishinv(:,:,i,j) = pdinv(Inuwish(:,:,i,j));
    end
end


% --------- get indices of upper triangle of p-by-p matrix
function d=itriu(p)

d=ones(p*(p-1)/2,1);
d(1+cumsum(0:p-2))=p+1:-1:3;
d = cumsum(d);