% matlab code generation for ...
% pgibbs_caiw_fast3e_mex
% [p_sm, p_sminv, p_neff] = pgibbs_caiw_fast3e_mex(p_sm0, yt, xt, nu, A, C, mu, PHI, B, V0inv, pg_c2r, pg_snr, pg_uu, pg_uu0);
clc; clear all; close all;
clear -mex;

is_office = 0;
if is_office ==0 % minchul's laptop
    
    setenv('MW_MINGW64_LOC','C:\TDM-GCC-64')
    addpath('cholinv');
    
elseif is_office == 1 % minchul's office
    
    setenv('MW_MINGW64_LOC','C:\TDM-GCC-64')
    addpath('cholinv_office');
    
elseif is_office == 2 %hpcc
    
end

%% Configuration
cfg = coder.config;
% ----------------- Safety (disable for faster execution) ---------------
% 
%                      IntegrityChecks: true
%                 ResponsivenessChecks: true
                 
% enable dynamic memory allocation for variable size matrices
cfg.DynamicMemoryAllocation = 'AllVariableSizeArrays';

% (p_sm0, yt, xt, nu, A, C, mu, PHI, B, V0inv, pg_c2r, pg_snr, pg_uu, pg_uu0)

t1 = coder.typeof(0,[Inf Inf Inf]); %p_sm0,
t2 = coder.typeof(0,[Inf Inf]); %yt,
t3 = coder.typeof(0,[Inf Inf]); %xt,
t4 = coder.typeof(0,[1]); %nu,
t5 = coder.typeof(0,[Inf Inf]); %A,
t6 = coder.typeof(0,[Inf Inf]); %C,
t7 = coder.typeof(0,[Inf Inf]); %mu,
t8 = coder.typeof(0,[Inf Inf]); %PHI,
t9 = coder.typeof(0,[Inf Inf]); %B,
t10 = coder.typeof(0,[Inf Inf]); %V0inv,
t11 = coder.typeof(0,[Inf Inf Inf]); %pg_c2r,
t12 = coder.typeof(0,[Inf Inf Inf]); %pg_snr,
t13 = coder.typeof(0,[Inf Inf]); %pg_uu,
t14 = coder.typeof(0,[Inf Inf]); %pg_uu0

if is_office == 0 % home computer (2016a version)
    % using extrinsic mex file
    codegen pgibbs_caiw_fast3e_mex -args {t1, t2, t3, t4, t5, t6, t7, t8, t9, t10, t11, t12, t13, t14} -config cfg -o pgibbs_caiw_fast3e_mex2016
    
    % using pdinv
    codegen pgibbs_caiw_fast7e_mex -args {t1, t2, t3, t4, t5, t6, t7, t8, t9, t10, t11, t12, t13, t14} -config cfg -o pgibbs_caiw_fast7e_mex2016
    
    % faster/unsafe version
    cfg.IntegrityChecks = false;
    cfg.ResponsivenessChecks = false;
    codegen pgibbs_caiw_fast7e_mex -args {t1, t2, t3, t4, t5, t6, t7, t8, t9, t10, t11, t12, t13, t14} -config cfg -o pgibbs_caiw_fast7e_mex2016f
    
elseif is_office == 1 %office computer (2017 version)
    % using extrinsic mex file
    codegen pgibbs_caiw_fast3e_mex -args {t1, t2, t3, t4, t5, t6, t7, t8, t9, t10, t11, t12, t13, t14} -config cfg -o pgibbs_caiw_fast3e_mex2017
    
    % using pdinv
    codegen pgibbs_caiw_fast7e_mex -args {t1, t2, t3, t4, t5, t6, t7, t8, t9, t10, t11, t12, t13, t14} -config cfg -o pgibbs_caiw_fast7e_mex2017
    
    % faster/unsafe version
    cfg.IntegrityChecks = false;
    cfg.ResponsivenessChecks = false;
    codegen pgibbs_caiw_fast7e_mex -args {t1, t2, t3, t4, t5, t6, t7, t8, t9, t10, t11, t12, t13, t14} -config cfg -o pgibbs_caiw_fast7e_mex2017f
    
elseif is_office == 2 %hpcc version
    
    % using pdinv
    codegen pgibbs_caiw_fast7e_mex -args {t1, t2, t3, t4, t5, t6, t7, t8, t9, t10, t11, t12, t13, t14} -config cfg -o pgibbs_caiw_fast7e_mex_hpcc
    
    % faster/unsafe version
    cfg.IntegrityChecks = false;
    cfg.ResponsivenessChecks = false;
    codegen pgibbs_caiw_fast7e_mex -args {t1, t2, t3, t4, t5, t6, t7, t8, t9, t10, t11, t12, t13, t14} -config cfg -o pgibbs_caiw_fast7e_mex_hpccf
    
end


