function a = mywishrnd(sigma,d,c2r,snr)
% a ~ Wish(sigma, df)
% inputs
% sigma
% d = upper chol of sigma
% c2r = chi2rnd(df-(0:n-1));
% snr = randn(n*(n-1)/2,1);

n = size(sigma,1);

% Load diagonal elements with square root of chi-square variates
% c2r = chi2rnd(df-(0:n-1));
a = diag(sqrt(c2r));

% Load upper triangle with independent normal (0, 1) variates
% snr = randn(n*(n-1)/2,1);
a(itriu(n)) = snr;

% Note
% Sig ~ W(V, nu) and C*Sig*C' ~ W(C*Sig*C', nu)
% Hence, to generate Sig ~ W(V, nu)
% step 1: V = D'*D
% step 2: S ~ W(I, nu)
% step 3: Sig = D'*S

% Desired matrix is D'(A'A)D
x = a(:,1:size(d,1))*d;

a = x' * x;

% --------- get indices of upper triangle of p-by-p matrix
function d=itriu(p)

d=ones(p*(p-1)/2,1);
d(1+cumsum(0:p-2))=p+1:-1:3;
d = cumsum(d);