%8-1-2017: This is a script to load in the Carriero, Clark, Marcellino
%paper
ndraws = 5000;
ndim   = 30;
numfacs = 2;

%First we load the VAR and vol-in-mean parameters
load('Pi.prn'); %This is a 930000 by 30 matrix
%My understanding is that the order of the VAR should be VAR coeffs, factor
%volatility 1, factor volatility 2 (look at line 94 of histdecomp.src)
% Let's reshape Pi to be 186 by 30 by 5000 matrix (there should be 186
% parameters for each regression - 180 from the VAR, and 6 from the volatilities)
[s1,s2] = size(Pi);
numcoeffs = s1/ndraws;
Pimat = zeros(numcoeffs,ndim,ndraws);

for i = 1:ndraws %we are doing this stupid slow way, just to be sure
    Pimat(:,:,i) = Pi((i-1)*numcoeffs+1:i*numcoeffs,:);
end

%Now we load the VAR parameters for the factor volatilities
load('factorcoef.prn'); %This is a 170000 by 2 matrix
%Order of the VAR should be VAR coeffs, regressors on the lagged level
%variables (look at line 107 of histdecomp.src)
% Let's reshape factorcoefff to be 34 by 5000 matrix (there should be 34
% parameters for each regression - 4 from the VAR and 30 from the lagged
% endogenous variables)
[ss1,ss2] = size(factorcoef);
numfcoeffs = ss1/ndraws;
factorcoefmat = zeros(numfcoeffs,numfacs,ndraws);

for i = 1:ndraws
    factorcoefmat(:,:,i) = factorcoef((i-1)*numfcoeffs+1:i*numfcoeffs,:);
end

%Finally we must load the volatility VCV matrix for the factor
%volatilities
PhiF = importdata('PhiF.prn'); %This is a 15000 by 1 matrix
PhiFmat = zeros(numfacs,numfacs,ndraws);

for i = 1:ndraws
    vcvtemp = PhiF((i-1)*3+1:i*3);
    vcvtemp2 = [vcvtemp(1) vcvtemp(2);vcvtemp(2) vcvtemp(3)]; %forming the VCV matrix
    PhiFmat(:,:,i) = vcvtemp2;
end